'$DYNAMIC
'$INCLUDE:'lf_core_head.bas'

CLS

IF COMMAND$ = "" THEN
  PRINT "Enter style name to generate: ";
  INPUT inname$
ELSE
  inname$ = COMMAND$
END IF

inname$ = ls_strip_spaces$(inname$)

PRINT "Loading INI file to memory..."

IF inname$ = "" THEN
  IF _FILEEXISTS("style.ini") = false THEN
    PRINT "ERROR: "; inname$; ".ini not found!"
    END
  END IF
  ininum = lfc_load_ini("style.ini")
ELSE
  IF _FILEEXISTS(inname$ + ".ini") = false THEN
    PRINT "ERROR: "; inname$; ".ini not found!"
    END
  END IF
  ininum = lfc_load_ini(inname$ + ".ini")
  inname$ = inname$ + "_"
END IF

PRINT "  INI file loaded."

stidnum$ = left$(lfc_get_ini_value$(ininum, "style_number"), 1)
if stidnum$ = "" or lfc_str$(val(stidnum$)) <> stidnum$ then
  stidnum$ = "X"
  Print "No style number defined."
  Print "Saving as groundXo.dat / vgagrX.dat."
else
  Print "Style number " + stidnum$ + "."
  Print "Saving as ground"; stidnum$ ;"o.dat / vgagr"; stidnum$ ;".dat."
end if

grfile = lfc_new_file(inname$ + "ground" + stidnum$ + "o.dat")
lfc_small_endian grfile

PRINT "Loading pallete..."

SELECT CASE lcase$(lfc_get_ini_value$(ininum, "pallete_info"))
  CASE "bmp"
    PRINT "    Style uses BMP file to define pallete."
    pimgnum = lfc_load_image(inname$ + "pallete.bmp")
    FOR x = 0 TO 15
      PRINT "    Loading color "; lfc_str$(x); "..."
      lfg_active_pallete(x).vga_red = INT(lfc_get_pixel_red(pimgnum, x, 0) / 4)
      lfg_active_pallete(x).vga_green = INT(lfc_get_pixel_green(pimgnum, x, 0) / 4)
      lfg_active_pallete(x).vga_blue = INT(lfc_get_pixel_blue(pimgnum, x, 0) / 4)
      lfg_active_pallete(x).ega_value = lfg_ega_color(lfc_get_pixel_red(pimgnum, x, 0), lfc_get_pixel_green(pimgnum, x, 0), lfc_get_pixel_blue(pimgnum, x, 0))
    NEXT
    lfc_close_image pimgnum
  CASE "24"
    PRINT "    Style uses INI-defined 24-bit colors."
    FOR x = 0 TO 15
      PRINT "    Loading color "; lfc_str$(x); "..."
      a$ = lfc_get_ini_value$(ininum, "pallete_" + lfc_str$(0))
      lfg_active_pallete(x).vga_red = INT(VAL(LEFT$(a$, 3)) / 4)
      lfg_active_pallete(x).vga_green = INT(VAL(MID$(a$, 4, 3)) / 4)
      lfg_active_pallete(x).vga_blue = INT(VAL(RIGHT$(a$, 3)) / 4)
      lfg_active_pallete(x).ega_value = lfg_ega_color(lfg_active_pallete(x).vga_red * 4, lfg_active_pallete(x).vga_green * 4, lfg_active_pallete(x).vga_blue * 4)
    NEXT
  CASE "18"
    PRINT "    Style uses INI-defined 18-bit colors."
    FOR x = 0 TO 15
      PRINT "    Loading color "; lfc_str$(x); "..."
      a$ = lfc_get_ini_value$(ininum, "pallete_" + lfc_str$(0))
      lfg_active_pallete(x).vga_red = INT(VAL(LEFT$(a$, 3)))
      lfg_active_pallete(x).vga_green = INT(VAL(MID$(a$, 4, 3)))
      lfg_active_pallete(x).vga_blue = INT(VAL(RIGHT$(a$, 3)))
      lfg_active_pallete(x).ega_value = lfg_ega_color(lfg_active_pallete(x).vga_red * 4, lfg_active_pallete(x).vga_green * 4, lfg_active_pallete(x).vga_blue * 4)
    NEXT
  CASE ELSE
    PRINT "ERROR: Pallete type must be BMP, 18 or 24."
    END
END SELECT
lfr_save_pallete grfile
PRINT "  Pallete successfully loaded."

PRINT "Encoding terrain pieces..."
tgfile = lfc_new_file(inname$ + "vgagrX.dat.0")
tgposit = 64
DIM putterdat AS lfr_terrain_data
FOR dopiece = 0 TO 63
  IF _FILEEXISTS(inname$ + "t" + lfc_pad_str$(dopiece, 2) + ".bmp") = false THEN
    IF dopiece = 0 THEN
      PRINT "ERROR: No terrain pieces found!"
      END
    ELSE
      PRINT "  All terrain pieces encoded."
      EXIT FOR
    END IF
  END IF
  PRINT "  Encoding piece "; lfc_str$(dopiece); "..."
  tim = lfc_load_image(inname$ + "t" + lfc_pad_str$(dopiece, 2) + ".bmp")
  IF lfc_images(tim, 0) MOD 8 <> 0 THEN
    PRINT "ERROR: Terrain piece "; lfc_str$(dopiece); " has a width not divisible by 8!"
    END
  END IF
  putterdat.width = lfc_images(tim, 0)
  putterdat.height = lfc_images(tim, 1)
  putterdat.image_loc = tgposit
  tgposit = lfg_encode_image(tim, tgfile, tgposit, 4, 0)
  putterdat.mask_loc = tgposit
  tgposit = lfg_encode_image(tim, tgfile, tgposit, 1, 1)
  lfr_put_terrain grfile, dopiece, putterdat
  lfc_close_image tim
NEXT

PRINT "Encoding objects..."
ogfile = lfc_new_file(inname$ + "vgagrX.dat.1")
ogposit = 64
DIM putterdat2 AS lfr_object_data
FOR doobj = 0 TO 15
  lfr_set_defaults putterdat2
  putterdat2.end_animation_frame_index = VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_frames"))
  IF putterdat2.end_animation_frame_index <= 0 THEN
    IF doobj < 2 THEN
      PRINT "ERROR: Graphic sets require at least two objects!"
      END
    END IF
    PRINT "  All objects encoded."
    EXIT FOR
  END IF
  IF _FILEEXISTS(inname$ + "o" + lfc_pad_str$(doobj, 2) + ".bmp") = false THEN
    PRINT "ERROR: Image file not found for object "; lfc_str$(doobj); "!"
    END
  END IF
  putterdat2.start_animation_frame_index = VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_start_frame"))
  putterdat2.trigger_effect_id = VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_type"))
  if putterdat2.trigger_effect_id <> 0 then
  putterdat2.trigger_left = INT(VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_left")) / 4)
  putterdat2.trigger_top = INT(VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_top")) / 4) + 1
  putterdat2.trigger_width = INT(VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_width")) / 4)
  putterdat2.trigger_height = INT(VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_height")) / 4)
  putterdat2.trap_sound_effect_id = VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_sound"))
  end if
  
  putterdat2.animation_frames_base_loc = ogposit
  
  IF putterdat2.end_animation_frame_index > 1 THEN putterdat2.animation_flags = 2
  IF VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_trigger_anim")) <> 0 THEN putterdat2.animation_flags = 1
  
  oim = lfc_load_image(inname$ + "o" + lfc_pad_str$(doobj, 2) + ".bmp")
  IF lfc_images(oim, 0) MOD 8 <> 0 THEN
    PRINT "ERROR: Object "; lfc_str$(doobj); " width is not divisble by 8!"
    END
  END IF
  IF doobj = 1 THEN
    IF lfc_images(oim, 0) <> 48 OR lfc_images(oim, 1) < 25 THEN
      PRINT "ERROR: Window must be exactly 48 pixels wide and at least 25 pixels tall!"
      END
    END IF
  END IF
  PRINT "  Encoding object "; lfc_str$(doobj); "..."
  lfr_set_obj_values_from_image oim, putterdat2
  lfr_set_obj_deriv_values putterdat2
  a = VAL(lfc_get_ini_value$(ininum, "object_" + lfc_str$(doobj) + "_preview_frame"))
  lfr_set_preview_image a, putterdat2
  IF doobj = 1 THEN lfr_set_window_values putterdat2
  
  FOR q = 1 TO putterdat2.end_animation_frame_index
    tmoim = lfc_sect_image(oim, 0, ((q - 1) * putterdat2.height), putterdat2.width, putterdat2.height)
    ogposit = lfg_encode_image(tmoim, ogfile, ogposit, 4, 0)
    ogposit = lfg_encode_image(tmoim, ogfile, ogposit, 1, 1)
    lfc_close_image tmoim
  NEXT
  
  lfr_put_object grfile, doobj, putterdat2
  lfc_close_image oim
NEXT

PRINT "Saving files to disk..."

vgagrfile = lfc_new_file(inname$ + "vgagr" + stidnum$ + ".dat")
lfd_encode_file vgagrfile, 0, tgfile, 0
lfd_encode_file vgagrfile, 1, ogfile, 0

lfc_save_file vgagrfile
lfc_save_file grfile
lfc_close_file grfile
lfc_close_file tgfile
lfc_close_file ogfile
lfc_close_file vgagrfile
lfc_close_ini ininum

END

FUNCTION ls_strip_spaces$ (instr$)
a$ = instr$
WHILE LEFT$(a$, 1) = " "
  a$ = MID$(a$, 2)
WEND
WHILE RIGHT$(a$, 1) = " "
  a$ = LEFT$(a$, LEN(a$) - 1)
WEND
ls_strip_spaces$ = a$
END FUNCTION

'$INCLUDE:'lf_core_foot.bas'
